<script lang="ts">
  import { clamp } from '@common/helpers/NumberHelper.js';
  import { isMobileView } from '@web-common/helpers/ResponsiveHelper.js';
  import { onMount } from 'svelte';
  import { enterWorld } from './world-store.js';

  let frame: HTMLDivElement;
  let gsap: GSAP;
  let mobileClipPath = 'inset(55px 20px 20px 20px round 20px)'; // Sync on both script and style

  $: $enterWorld ? enterTween() : exitTween();

  const getClipPathInset = () => {
    if (isMobileView()) return mobileClipPath;

    const calculateSpacing = () => {
      const viewportWidth = window.innerWidth; // Get viewport width
      const commonSpacing = 20;
      let spacingLeft = commonSpacing; // Default spacing for smaller screens
      let spacingRight = commonSpacing; // Default spacing for smaller screens

      const maxWidthPixels = 1000; // Max-width in pixels
      const buffer = 4; // ? Can't get exact calculation?
      const modMaxWidth = maxWidthPixels - spacingLeft - spacingRight;
      if (viewportWidth > maxWidthPixels) {
        const actualWidth = (viewportWidth * 100) / 100; // 100vw in pixels
        const remainingSpace = actualWidth - modMaxWidth;
        const remainingSpacePerSide = remainingSpace / 2;

        // Adjust for clip-path
        spacingLeft = remainingSpacePerSide - commonSpacing - buffer;
        spacingRight = remainingSpacePerSide - commonSpacing + buffer;
      }

      return {
        left: clamp(spacingLeft, commonSpacing, Number.MAX_SAFE_INTEGER),
        right: clamp(spacingRight, commonSpacing, Number.MAX_SAFE_INTEGER),
      };
    };

    const spacing = { left: 20, right: 20 } || calculateSpacing();

    return `inset(70px ${spacing.right}px 20px ${spacing.left}px round 20px)`;
  };

  const enterTween = () => {
    gsap?.fromTo(
      frame,
      {
        clipPath: getClipPathInset(),
      },
      {
        duration: 0.8,
        clipPath: 'inset(0px 0px 0px 0px round 0px)',
        ease: 'back.inOut',
      },
    );
  };

  const exitTween = () => {
    gsap?.to(frame, {
      duration: 0.8,
      clipPath: getClipPathInset(),
      ease: 'back.inOut',
    });
  };

  const updateSize = () => {
    frame.style.clipPath = getClipPathInset();
  };

  onMount(async () => {
    gsap = (await import('gsap/all')).gsap;
    updateSize();
  });

  const onResize = () => {
    if ($enterWorld) return;
    updateSize();
  };
</script>

<svelte:window on:resize={onResize} />

<div
  bind:this={frame}
  class="masked-frame">
  <slot />
  {#if !$enterWorld}
    <button on:click />
  {/if}
</div>

<style>
  .masked-frame {
    width: 100%;
    height: 100%;
  }

  button {
    position: absolute;
    top: 0;
    width: 100%;
    height: 100%;
  }
</style>
